/*
 * Created on 2004/08/16
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.swt.ui;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Text;



/**
 * 
 *
 */
public class FileDirChoicer extends Canvas implements SelectionListener{

    /**
     * @param arg0
     * @param arg1
     */
    public static final int FILE=0;
    public static final int DIR=1;
    Layout rowLayout;
    Layout rootLayoutData;
    RowData labelLayoutData;
    RowData textLayoutData;
    RowData buttonLayoutData;
    private Button button;
    private Label label;
    private Text text;
    private int type;
    private String[] alowExtensions;
    FileStatusChanger fileListChanger;
  
    public void setEnabled(boolean bool){
        super.setEnabled(bool);
        label.setEnabled(bool);
        text.setEnabled(bool);
        button.setEnabled(bool);
    }
    public  void removeFileListChangeListener(FileStatusChangeListener listener){
        fileListChanger.removeFileListChangeListener(listener);   
       }
       
       public  void addFileListChangeListener(FileStatusChangeListener listener){
           fileListChanger.addFileListChangeListener(listener);   
          }
    public FileDirChoicer(Composite arg0, int arg1,int type,String labelText) {
        
        super(arg0, arg1);
        fileListChanger=new FileStatusChanger();
        RowData data=new RowData();
        data.height=24;
        setLayoutData(data);
        this.type=type;
        rowLayout=new RowLayout();
        setLayout(rowLayout);
        label = new Label(this,SWT.NULL);
        if(labelText!=null){
            label.setText(labelText);
            labelLayoutData=new RowData();
            labelLayoutData.width=100;
            label.setLayoutData(labelLayoutData);
        }
        
        text = new Text(this,SWT.READ_ONLY);
        textLayoutData=new RowData();
        textLayoutData.width=200;
        text.setLayoutData(textLayoutData);
        text.setBackground(new Color(this.getShell().getDisplay(),255,255,255));
        
        button = new Button(this,SWT.NULL);
        button.setText("Q");
        buttonLayoutData=new RowData();
        buttonLayoutData.width=50;
        button.setLayoutData(buttonLayoutData);
        button.addSelectionListener(this);
    }
    /* (non-Javadoc)
     * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
     */
    public void widgetSelected(SelectionEvent event) {
       if(event.getSource()==button){
          if(type==FILE){
              openFileDialog();
          }else{
              openDirectoryDialog();
          }
       }
    }
    /**
     * 
     */
    private void openDirectoryDialog() {
        DirectoryDialog dialog=new DirectoryDialog(this.getShell());
        
        String result=dialog.open();
        if(result!=null){
            text.setText(result);
        }
    }
    /**
     * 
     */
    private void openFileDialog() {
        FileDialog dialog=new FileDialog(this.getShell());
        
        if(alowExtensions!=null){
            dialog.setFilterExtensions(alowExtensions);
        }
        String result=dialog.open();
        
    }
    
    private void setFilePathLabel(String path){
        if(path!=null){
            text.setText(path);
            fileListChanger.fireAddFile(path);
        }
    }
    public void removePath(){
        String path=text.getText();
        if(!path.equals("")){
            fileListChanger.fireAddFile(path);
            text.setText("");
        }
    }
    /* (non-Javadoc)
     * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
     */
    public void widgetDefaultSelected(SelectionEvent arg0) {
       
    }
    
    public void setFile(File file){
        if(file!=null){
        text.setText(file.getAbsolutePath());
        }else{
            text.setText("");
        }
    }
    
    public File getFile(){
        File file=null;
        if(!text.getText().equals("")){
            file=new File(text.getText());
        }
        return file;
    }

    public String[] getAlowExtensions() {
        return alowExtensions;
    }
    public void setAlowExtensions(String[] alowExtensions) {
        this.alowExtensions = alowExtensions;
    }
}
